



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>温习排序算法（基于C指针）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">温习排序算法（基于C指针）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 18:00:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><em><strong>以前学过的数据结构课，貌似已经忘得一干二净了，偶然又翻起，书中最后一章详细介绍了7种排序算法，现在对其中4种做个总结。（为啥只总结4种，当然是因为偷懒，只想总结简单又常用的！）</strong></em></p>
<p>先贴一张排序分类图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1377659/201808/1377659-20180820150636204-1607680860.jpg" /></p>
<h2>1.冒泡法：</h2>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums"><strong>主要思想：每次比较相邻的两个数，较小的数向上冒，较大的数向下沉。</strong></pre>
</td>
</tr>
</tbody>
</table>
<p>演示效果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1377659/201808/1377659-20180820145047384-1260708965.gif" /></p>
<p>C代码：（指针p指向待排序列的首地址，length是待排序列的总长度，下同）</p>
<div>
<pre class="prettyprint linenums">swap(int *p1, int *p2)<br />
{<br />
    int tmp;<br />
    tmp = *p1;<br />
    *p1 = *p2;<br />
    *p2 = tmp;<br />
}

Msort(int *p, int length)<br />
{<br />
    BOOLEAN flag = TRUE;<br />
    for (int i = ; i &lt; length &amp;&amp; flag; i++){<br />
        flag = FALSE;<br />
        for (int j = length - ; j &gt; i; j--)<br />
            if (*(p + j) &lt; *(p + j - ))<br />
            {<br />
                swap(p + j, p + j - );<br />
                flag = TRUE;<br />
            }<br />
    }<br />
}</pre>
</div>
<h2>2.简单选择法：</h2>
<table>
<tbody>
<tr>
<td><strong>&nbsp; 主要思想：每轮循环找到一个最小数的标号，循环结束后进行一次交换。</strong></td>
</tr>
</tbody>
</table>
<p>演示效果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1377659/201808/1377659-20180820145129573-308339942.gif" /></p>
<p>C代码：</p>
<div>
<pre class="prettyprint linenums">swap(int *p1, int *p2)<br />
{<br />
    int tmp;<br />
    tmp = *p1;<br />
    *p1 = *p2;<br />
    *p2 = tmp;<br />
}<br />
Xsort(int *p, int length)<br />
{<br />
    for (int i = ; i &lt; length - ; i++){<br />
        int min = i;<br />
        for (int j = i + ; j &lt; length; j++){<br />
            if (*(p + j) &lt; *(p + min))<br />
                min = j;<br />
        }<br />
        if (min != i)<br />
            swap(p + i, p + min);<br />
    }<br />
}</pre>
</div>
<h2>3.直接插入法：</h2>
<table>
<tbody>
<tr>
<td><strong>&nbsp; &nbsp;主要思想：每轮循环都是实现将一个新来的数插入到原有的一个有序子序列中。</strong></td>
</tr>
</tbody>
</table>
<p>演示效果：</p>
<p>　&nbsp;<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1377659/201808/1377659-20180820145237294-1869034311.gif" /></p>
<p>C代码：</p>
<div>
<pre class="prettyprint linenums">swap(int *p1, int *p2)<br />
{<br />
    int tmp;<br />
    tmp = *p1;<br />
    *p1 = *p2;<br />
    *p2 = tmp;<br />
}

Csort(int *p, int length)<br />
{<br />
    for (int i = ; i &lt; length; i++){<br />
        if (*(p + i) &lt; *(p + i - )){<br />
            int tmp = *(p + i);<br />
            int j;<br />
            for (j = i - ; j &gt;=  &amp;&amp; *(p + j) &gt; tmp; j--)<br />
                *(p + j + ) = *(p + j);<br />
            *(p + j + ) = tmp;<br />
        }<br />
    }<br />
}</pre>
</div>
<h2>4.快速排序法：</h2>
<p>冒泡排序的升级版，同属于交换排序。</p>
<table>
<tbody>
<tr>
<td><strong>&nbsp; &nbsp;主要思想：通过递归，不断地二分序列，使相对较大的数位于一边，相对较小的数位于另一边。</strong></td>
</tr>
</tbody>
</table>
<p>演示效果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1377659/201808/1377659-20180820145312402-1470539736.gif" /></p>
<p>C代码：</p>
<div>
<pre class="prettyprint linenums">swap(int *p1, int *p2)<br />
{<br />
    int tmp;<br />
    tmp = *p1;<br />
    *p1 = *p2;<br />
    *p2 = tmp;<br />
}

int partition(int *p, int startIdx, int endIdx)<br />
{<br />
    int pivotkey;<br />
    pivotkey = *(p + startIdx);<br />
    while (startIdx &lt; endIdx)<br />
    {<br />
        while (startIdx &lt; endIdx &amp;&amp; *(p + endIdx) &gt;= pivotkey)<br />
            endIdx--;<br />
        swap(p + startIdx, p + endIdx);

        while (startIdx &lt; endIdx &amp;&amp; *(p + startIdx) &lt;= pivotkey)<br />
            startIdx++;<br />
        swap(p + startIdx, p + endIdx);<br />
    }<br />
    return startIdx;<br />
}

Ksort(int *p, int startIdx,int endIdx)<br />
{<br />
    int pivot;<br />
    if (startIdx &lt; endIdx)<br />
    {<br />
        pivot = partition(p,startIdx,endIdx);<br />
        Ksort(p, startIdx, pivot - );<br />
        Ksort(p, pivot + , endIdx);<br />
    }<br />
}</pre>
</div>
<h2>5.举例：</h2>
<div>
<pre class="prettyprint linenums">//2018-8-20<br />
//by-lengwawa

#include&lt;stdio.h&gt;<br />
#include&lt;Windows.h&gt;   //程序中的BOOLEAN在该头文件中定义

main()<br />
{<br />
    int n, i;<br />
    int *p;<br />
    p = NULL;

    printf("请输入需要排序的个数：");<br />
    scanf_s("%d", &amp;n);<br />
    p = (int *)malloc(n*sizeof(int));

    printf("\n请输入%d个待排序的数：", n);<br />
    for (int k = ; k &lt; n; k++)<br />
        scanf_s("%d", p + k);

    printf("\n你要使用哪种排序法(1&mdash;&mdash;冒泡 2&mdash;&mdash;选择 3&mdash;&mdash;插入 4&mdash;&mdash;快排)：");

    scanf_s("%d", &amp;i);

    printf("\n");<br />
    if (i == )<br />
    {<br />
        printf("使用冒泡排序法的结果是：");<br />
        Msort(p, n);<br />
        for (int j = ; j &lt; n; j++)<br />
            printf("%d ", *(p + j));<br />
        printf("\n\n\n");<br />
    }<br />
    else if (i == )<br />
    {<br />
        printf("使用选择排序法的结果是：");<br />
        Xsort(p, n);<br />
        for (int j = ; j &lt; n; j++)<br />
            printf("%d ", *(p + j));<br />
        printf("\n\n\n");<br />
    }<br />
    else if (i == )<br />
    {<br />
        printf("使用插入排序法的结果是：");<br />
        Csort(p, n);<br />
        for (int j = ; j &lt; n; j++)<br />
            printf("%d ", *(p + j));<br />
        printf("\n\n\n");<br />
    }<br />
    else<br />
    {<br />
        printf("使用快速排序法的结果是：");<br />
        Ksort(p, , n - );//这里是标号，所以是n-1<br />
        for (int j = ; j &lt; n; j++)<br />
            printf("%d ", *(p + j));<br />
        printf("\n\n\n");<br />
    }<br />
}</pre>
</div>
<h2>6.输出：</h2>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1377659/201808/1377659-20180820142106889-248756391.png" /></p>
<h2>7.把另外3个的gif演示放一下吧，有兴趣的看看</h2>
<p>选择法升级版&mdash;&mdash;<strong>堆排序</strong>：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1377659/201808/1377659-20180820150333468-2103084075.gif" /></p>
<p>插入法升级版&mdash;&mdash;<strong>希尔排序</strong>：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1377659/201808/1377659-20180820150411737-1561741764.gif" /></p>
<p><strong>归并排序：</strong></p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1377659/201808/1377659-20180820150436924-1772250154.gif" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqd7zzqd.html">Razor 语法初级使用，不断更新此文章</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdjw50q.html">1-1 gulp 实战</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ojr539.html">masonry插件和infinitescroll插件实现无刷新无分页完美瀑布流</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okjyre9.html">关于HttpWebRequest&period;KeepAlive</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmj5549.html">（二）java特征</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn12p2g8.html">Error loading&colon; &bsol;Java&bsol;jdk1&period;6&period;0&lowbar;35&bsol;jre&bsol;bin&bsol;server&bsol;jvm&period;dll</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7md6rjq.html">&period;net平台下C&num;socket通信（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okpn419.html">wxWidgets一个界面与数据分离的简单例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy111zmq.html">dpdk组态 千兆网卡 驱动 失败 原因分析及 解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mejvmpq.html">关于单选按钮在提交时获取所选择的选项得value值问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojll5pq.html">磁盘管理 之 parted命令添加swap，文件系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16xloq.html">PHP7--PHP的一次重大变革</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rmorz8.html">使用有序GUID：提升其在各数据库中作为主键时的性能</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rwdl08.html">tomcat的缺少tcnative-1&period;dll的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw325v9.html">OneNET麒麟座应用开发之七：控制采样电机</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zypoev9.html">spring继承Rabbitmq client-----------------------待研究</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvxe2j8.html">python-django rest framework框架之序列化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ox1wq.html">&lpar;转&rpar;Python新手写出漂亮的爬虫代码2&mdash;&mdash;从json获取信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vm3lzq.html">java入门--4111&colon;判断游戏胜者-Who Is the Winner</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjn5o08.html">linux nohup screen注解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jzk3y48.html">Nuxt框架，ssr服务器渲染解决单页面应用的 SEO 问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1x43jq.html">Java的家庭记账本程序（J）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpwye79.html">DOS批处理高级教程（还不错）（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p11yv8.html">python 2&period;7 数据结构之列表list&colon; 基础面试总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj3r028.html">Python3中的真值测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meomd0q.html">Eclipse4&period;8&period;0的svn插件离线安装说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kgmxz9.html">APP，H5测试要点</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp6pvjq.html">跑的飞快的dinic</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mwrmm8.html">jade模版js中接收express的res&period;render</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1evwmq.html">defer 内追踪变量变化</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
